## webdis 0.1.1

=== Makefile ===
OUT=webdis
HIREDIS_OBJ?=hiredis/hiredis.o hiredis/sds.o hiredis/net.o hiredis/async.o
JANSSON_OBJ?=jansson/src/dump.o jansson/src/error.o jansson/src/hashtable.o jansson/src/load.o jansson/src/strbuffer.o jansson/src/utf.o jansson/src/value.o jansson/src/variadic.o
B64_OBJS?=b64/cencode.o
FORMAT_OBJS?=formats/json.o formats/raw.o formats/common.o formats/custom-type.o
HTTP_PARSER_OBJS?=http-parser/http_parser.o

CFLAGS ?= -O0 -ggdb -Wall -Wextra -I. -Ijansson/src -Ihttp-parser
LDFLAGS ?= -levent -pthread

# check for MessagePack
MSGPACK_LIB=$(shell ls /usr/lib/libmsgpack.so 2>/dev/null)
ifneq ($(strip $(MSGPACK_LIB)),)
	FORMAT_OBJS += formats/msgpack.o
	CFLAGS += -DMSGPACK=1
	LDFLAGS += -lmsgpack
endif


DEPS=$(FORMAT_OBJS) $(HIREDIS_OBJ) $(JANSSON_OBJ) $(HTTP_PARSER_OBJS) $(B64_OBJS)
OBJS=webdis.o cmd.o worker.o slog.o server.o acl.o md5/md5.o sha1/sha1.o http.o client.o websocket.o pool.o conf.o $(DEPS)



PREFIX ?= /usr/local
CONFDIR ?= $(DESTDIR)/etc

INSTALL_DIRS = $(DESTDIR) \
	       $(DESTDIR)/$(PREFIX) \
	       $(DESTDIR)/$(PREFIX)/bin \
	       $(CONFDIR)

all: $(OUT) Makefile

$(OUT): $(OBJS) Makefile
	$(CC) -o $(OUT) $(OBJS) $(LDFLAGS)

%.o: %.c %.h Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

%.o: %.c Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

$(INSTALL_DIRS):
	mkdir -p $@

clean:
	rm -f $(OBJS) $(OUT)

install: $(OUT) $(INSTALL_DIRS)
	cp $(OUT) $(DESTDIR)/$(PREFIX)/bin
	cp webdis.prod.json $(CONFDIR)


WEBDIS_PORT ?= 7379

test_all: test perftest

test:
	python tests/basic.py
	python tests/limits.py
	./tests/pubsub -p $(WEBDIS_PORT)

perftest:
	# This is a performance test that requires apache2-utils and curl
	./tests/bench.sh

=== hiredis/Makefile ===
# Hiredis Makefile
# Copyright (C) 2010-2011 Salvatore Sanfilippo <antirez at gmail dot com>
# Copyright (C) 2010-2011 Pieter Noordhuis <pcnoordhuis at gmail dot com>
# This file is released under the BSD license, see the COPYING file

OBJ=net.o hiredis.o sds.o async.o
BINS=hiredis-example hiredis-test
LIBNAME=libhiredis

HIREDIS_MAJOR=0
HIREDIS_MINOR=10

# Fallback to gcc when $CC is not in $PATH.
CC:=$(shell sh -c 'type $(CC) >/dev/null 2>/dev/null && echo $(CC) || echo gcc')
OPTIMIZATION?=-O3
WARNINGS=-Wall -W -Wstrict-prototypes -Wwrite-strings
DEBUG?= -g -ggdb
REAL_CFLAGS=$(OPTIMIZATION) -fPIC $(CFLAGS) $(WARNINGS) $(DEBUG)
REAL_LDFLAGS=$(LDFLAGS)

DYLIBSUFFIX=so
STLIBSUFFIX=a
DYLIB_MINOR_NAME=$(LIBNAME).$(DYLIBSUFFIX).$(HIREDIS_MAJOR).$(HIREDIS_MINOR)
DYLIB_MAJOR_NAME=$(LIBNAME).$(DYLIBSUFFIX).$(HIREDIS_MAJOR)
DYLIBNAME=$(LIBNAME).$(DYLIBSUFFIX)
DYLIB_MAKE_CMD=$(CC) -shared -Wl,-soname,$(DYLIB_MINOR_NAME) -o $(DYLIBNAME) $(LDFLAGS)
STLIBNAME=$(LIBNAME).$(STLIBSUFFIX)
STLIB_MAKE_CMD=ar rcs $(STLIBNAME)

# Platform-specific overrides
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
ifeq ($(uname_S),SunOS)
  REAL_LDFLAGS+= -ldl -lnsl -lsocket
  DYLIB_MAKE_CMD=$(CC) -G -o $(DYLIBNAME) -h $(DYLIB_MINOR_NAME) $(LDFLAGS)
  INSTALL= cp -r
endif
ifeq ($(uname_S),Darwin)
  DYLIBSUFFIX=dylib
  DYLIB_MINOR_NAME=$(LIBNAME).$(HIREDIS_MAJOR).$(HIREDIS_MINOR).$(DYLIBSUFFIX)
  DYLIB_MAJOR_NAME=$(LIBNAME).$(HIREDIS_MAJOR).$(DYLIBSUFFIX)
  DYLIB_MAKE_CMD=$(CC) -shared -Wl,-install_name,$(DYLIB_MINOR_NAME) -o $(DYLIBNAME) $(LDFLAGS)
endif

all: $(DYLIBNAME) $(BINS)

# Deps (use make dep to generate this)
net.o: net.c fmacros.h net.h hiredis.h
async.o: async.c async.h hiredis.h sds.h dict.c dict.h
example.o: example.c hiredis.h
hiredis.o: hiredis.c fmacros.h hiredis.h net.h sds.h
sds.o: sds.c sds.h
test.o: test.c hiredis.h

$(DYLIBNAME): $(OBJ)
	$(DYLIB_MAKE_CMD) $(OBJ)

$(STLIBNAME): $(OBJ)
	$(STLIB_MAKE_CMD) $(OBJ)

dynamic: $(DYLIBNAME)
static: $(STLIBNAME)

# Binaries:
hiredis-example-libevent: example-libevent.c adapters/libevent.h $(STLIBNAME)
	$(CC) -o $@ $(REAL_CFLAGS) $(REAL_LDFLAGS) -levent example-libevent.c $(STLIBNAME)

hiredis-example-libev: example-libev.c adapters/libev.h $(STLIBNAME)
	$(CC) -o $@ $(REAL_CFLAGS) $(REAL_LDFLAGS) -lev example-libev.c $(STLIBNAME)

ifndef AE_DIR
hiredis-example-ae:
	@echo "Please specify AE_DIR (e.g. <redis repository>/src)"
	@false
else
hiredis-example-ae: example-ae.c adapters/ae.h $(STLIBNAME)
	$(CC) -o $@ $(REAL_CFLAGS) $(REAL_LDFLAGS) -I$(AE_DIR) $(AE_DIR)/ae.o $(AE_DIR)/zmalloc.o example-ae.c $(STLIBNAME)
endif

hiredis-%: %.o $(STLIBNAME)
	$(CC) -o $@ $(REAL_LDFLAGS) $< $(STLIBNAME)

test: hiredis-test
	./hiredis-test

check: hiredis-test
	echo \
		"daemonize yes\n" \
		"pidfile /tmp/hiredis-test-redis.pid\n" \
		"port 56379\n" \
		"bind 127.0.0.1\n" \
		"unixsocket /tmp/hiredis-test-redis.sock" \
			| redis-server -
	./hiredis-test -h 127.0.0.1 -p 56379 -s /tmp/hiredis-test-redis.sock || \
			( kill `cat /tmp/hiredis-test-redis.pid` && false )
	kill `cat /tmp/hiredis-test-redis.pid`

.c.o:
	$(CC) -std=c99 -pedantic -c $(REAL_CFLAGS) $<

clean:
	rm -rf $(DYLIBNAME) $(STLIBNAME) $(BINS) hiredis-example* *.o *.gcda *.gcno *.gcov

dep:
	$(CC) -MM *.c

# Installation related variables and target
PREFIX?=/usr/local
INCLUDE_PATH?=include/hiredis
LIBRARY_PATH?=lib
INSTALL_INCLUDE_PATH= $(PREFIX)/$(INCLUDE_PATH)
INSTALL_LIBRARY_PATH= $(PREFIX)/$(LIBRARY_PATH)

ifeq ($(uname_S),SunOS)
  INSTALL?= cp -r
endif

INSTALL?= cp -a

install: $(DYLIBNAME) $(STLIBNAME)
	mkdir -p $(INSTALL_INCLUDE_PATH) $(INSTALL_LIBRARY_PATH)
	$(INSTALL) hiredis.h async.h adapters $(INSTALL_INCLUDE_PATH)
	$(INSTALL) $(DYLIBNAME) $(INSTALL_LIBRARY_PATH)/$(DYLIB_MINOR_NAME)
	cd $(INSTALL_LIBRARY_PATH) && ln -sf $(DYLIB_MINOR_NAME) $(DYLIB_MAJOR_NAME)
	cd $(INSTALL_LIBRARY_PATH) && ln -sf $(DYLIB_MAJOR_NAME) $(DYLIBNAME)
	$(INSTALL) $(STLIBNAME) $(INSTALL_LIBRARY_PATH)

32bit:
	@echo ""
	@echo "WARNING: if this fails under Linux you probably need to install libc6-dev-i386"
	@echo ""
	$(MAKE) CFLAGS="-m32" LDFLAGS="-m32"

gprof:
	$(MAKE) CFLAGS="-pg" LDFLAGS="-pg"

gcov:
	$(MAKE) CFLAGS="-fprofile-arcs -ftest-coverage" LDFLAGS="-fprofile-arcs"

coverage: gcov
	make check
	mkdir -p tmp/lcov
	lcov -d . -c -o tmp/lcov/hiredis.info
	genhtml --legend -o tmp/lcov/report tmp/lcov/hiredis.info

noopt:
	$(MAKE) OPTIMIZATION=""

.PHONY: all test check clean dep install 32bit gprof gcov noopt

=== debian/changelog ===
webdis (0.1.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove embedded code copies (hiredis, jansson) in the clean target
    to make sure not to use them; this notably fixes the FTBFS during
    the libhiredis0.10 → libhiredis0.13 transition (Closes: #785476).

 -- Cyril Brulebois <kibi@debian.org>  Tue, 14 Jul 2015 18:32:13 +0200

webdis (0.1.1-2) unstable; urgency=medium

  * Use correct license names in debian/copyright
  * Document hiredis and jansson libraries
  * Add autopkgtest support
  * Update Standards-Version to 3.9.6. No changes required

 -- Andriy Senkovych <jolly_roger@itblog.org.ua>  Fri, 24 Oct 2014 22:48:16 +0300

webdis (0.1.1-1) unstable; urgency=low

  * Initial release (Closes: #623528)

 -- Andriy Senkovych <jolly_roger@itblog.org.ua>  Mon, 04 Aug 2014 02:10:55 +0300

=== debian/control ===
Source: webdis
Section: web
Priority: optional
Maintainer: Andriy Senkovych <jolly_roger@itblog.org.ua>
Build-Depends: debhelper (>= 7.0.50~), 
    libevent-dev (>= 1.4.13), 
    libhiredis-dev (>= 0.10),
    libjansson-dev (>= 1.3),
    libb64-dev (>= 1.2),
    libmsgpack-dev,
    redis-server,
    python-unittest2,
    python-msgpack (>= 0.3),
    net-tools
Standards-Version: 3.9.6
Vcs-Git: git://github.com/jollyroger/webdis.git -b debian
Vcs-Browser: https://github.com/jollyroger/webdis
Homepage: http://webd.is
Testsuite: autopkgtest

Package: webdis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Suggests: redis-server
Description: simple web server providing an HTTP interface to Redis
 Webdis is a simple web server providing HTTP interface to Redis. Some features
 include:
  * Support for GET and POST requests.
  * JSON output by default, optional JSONP parameter (?jsonp=myFunction).
  * Raw Redis 2.0 protocol output with .raw suffix
  * HTTP 1.1 pipelining (50,000 http requests per second on a desktop Linux
    machine.)
  * Restricted commands by IP range (CIDR subnet + mask) or HTTP Basic Auth,
    returning 403 errors.
  * Possible Redis authentication in the config file.
  * Pub/Sub using Transfer-Encoding: chunked, works with JSONP as well. Webdis
    can be used as a Comet server.
  * Custom Content-Type using a pre-defined file extension, or with
    ?type=some/thing.
  * URL-encoded parameters for binary data or slashes.
  * Logs, with a configurable verbosity.
  * Cross-origin XHR, if compiled with libevent2 (for OPTIONS support).
  * File upload with PUT.
  * With the JSON output, the return value of INFO is parsed and transformed
    into an object.

Package: webdis-dbg
Priority: extra
Architecture: any
Section: debug
Depends: ${misc:Depends}, webdis (= ${binary:Version})
Description: webdis debugging symbols
 Webdis is a simple web server providing HTTP interface to Redis.
 .
 This package provides debug symbols for webdis.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export PREFIX = /usr
export DESTDIR = $(CURDIR)/debian/tmp
export CONFDIR = $(DESTDIR)/etc/webdis

CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

# Add CPPFLAGS TO CFLAGS since build system does not know about them.
CFLAGS += $(CPPFLAGS)

# Objects to be removed from build procedure
export HIREDIS_OBJ=
export JANSSON_OBJ=
export B64_OBJS=

export CFLAGS += -I. -Ihttp-parser
export LDFLAGS += -levent -pthread -lhiredis -ljansson -lb64

build: build-arch
build-arch: tests/pubsub tests/websocket

tests/% :
	$(MAKE) -C tests $*

%:
	dh $@

override_dh_strip:
	dh_strip --dbg-package=webdis-dbg

override_dh_auto_clean:
	$(MAKE) clean
	$(MAKE) -C tests clean
	# Make sure not to use embedded code copies:
	rm -rf hiredis jansson

override_dh_auto_test:
ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	@echo "Skipping check (disabled in DEB_BUILD_OPTIONS)."
else
	$(CURDIR)/debian/test.sh $(MAKE) test
endif

=== debian/watch ===
version=3
opts=dversionmangle=s/\+(dfsg|ds)$// \
    https://github.com/nicolasff/webdis/releases \
    .*\/([0-9.]+)\.tar\.gz

## webdis 0.1.2+dfsg

=== debian/changelog ===
webdis (0.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 0.1.2+dfsg
  * Move repository to collab-maint on alioth
  * Repack upstream tarball to remove hiredis, jansson and b64 copies
  * Drop copyright notices for removed libraries
  * Update Standards-Version to 3.9.8. No changes required
  * Raise compat level to 10
  * Add explicit dependency on lsb-base
  * Enable all hardening features during build

 -- Andriy Senkovych <jolly_roger@itblog.org.ua>  Thu, 10 Nov 2016 01:36:21 +0200

webdis (0.1.1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with recent msgpack-c versions.  (Closes: #811343)
    + Use pkg-config to determine CFLAGS/LDFLAGS
      - Search for msgpackc library in both MA and non-MA directories to ease
        backports
    + Use different APIs for the RAW type, based on the version of msgpack-c

 -- James McCoy <jamessan@debian.org>  Thu, 21 Jul 2016 23:43:34 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: web
 Priority: optional
 Maintainer: Andriy Senkovych <jolly_roger@itblog.org.ua>
-Build-Depends: debhelper (>= 7.0.50~), 
+Build-Depends: debhelper (>= 10),
     libevent-dev (>= 1.4.13), 
     libhiredis-dev (>= 0.10),
     libjansson-dev (>= 1.3),
@@ -12,15 +12,15 @@
     python-unittest2,
     python-msgpack (>= 0.3),
     net-tools
-Standards-Version: 3.9.6
-Vcs-Git: git://github.com/jollyroger/webdis.git -b debian
-Vcs-Browser: https://github.com/jollyroger/webdis
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/webdis.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/webdis.git
 Homepage: http://webd.is
 Testsuite: autopkgtest
 
 Package: webdis
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lsb-base (>= 3.0-6)
 Suggests: redis-server
 Description: simple web server providing an HTTP interface to Redis
  Webdis is a simple web server providing HTTP interface to Redis. Some features

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 export PREFIX = /usr
 export DESTDIR = $(CURDIR)/debian/tmp
 export CONFDIR = $(DESTDIR)/etc/webdis
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
 
 CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
 CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
@@ -22,14 +24,12 @@
 export CFLAGS += -I. -Ihttp-parser
 export LDFLAGS += -levent -pthread -lhiredis -ljansson -lb64
 
-build: build-arch
-build-arch: tests/pubsub tests/websocket
-
-tests/% :
-	$(MAKE) -C tests $*
-
 %:
 	dh $@
+
+override_dh_auto_build:
+	dh_auto_build
+	$(MAKE) -C tests pubsub websocket
 
 override_dh_strip:
 	dh_strip --dbg-package=webdis-dbg
@@ -37,8 +37,8 @@
 override_dh_auto_clean:
 	$(MAKE) clean
 	$(MAKE) -C tests clean
-	# Make sure not to use embedded code copies:
-	rm -rf hiredis jansson
+	rm -f debian/files
+	dh_auto_clean
 
 override_dh_auto_test:
 ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
@@ -46,3 +46,4 @@
 else
 	$(CURDIR)/debian/test.sh $(MAKE) test
 endif
+

## webdis 0.1.4%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: webdis
 Section: web
 Priority: optional
-Maintainer: Andriy Senkovych <jolly_roger@itblog.org.ua>
-Build-Depends: debhelper (>= 10),
-    libevent-dev (>= 1.4.13), 
+Maintainer: Andrii Senkovych <andrii@senkovych.com>
+Build-Depends: debhelper (>= 11~),
+    libevent-dev (>= 1.4.13),
     libhiredis-dev (>= 0.10),
     libjansson-dev (>= 1.3),
     libb64-dev (>= 1.2),
@@ -11,12 +11,12 @@
     redis-server,
     python-unittest2,
     python-msgpack (>= 0.3),
-    net-tools
-Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/webdis.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/webdis.git
+    pkg-config
+Standards-Version: 4.2.0
+Vcs-Git: https://salsa.debian.org/debian/webdis.git
+Vcs-Browser: https://salsa.debian.org/debian/webdis
 Homepage: http://webd.is
-Testsuite: autopkgtest
+Rules-Requires-Root: no
 
 Package: webdis
 Architecture: any
@@ -43,13 +43,3 @@
   * File upload with PUT.
   * With the JSON output, the return value of INFO is parsed and transformed
     into an object.
-
-Package: webdis-dbg
-Priority: extra
-Architecture: any
-Section: debug
-Depends: ${misc:Depends}, webdis (= ${binary:Version})
-Description: webdis debugging symbols
- Webdis is a simple web server providing HTTP interface to Redis.
- .
- This package provides debug symbols for webdis.

## webdis 0.1.4+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 OUT=webdis
-HIREDIS_OBJ?=hiredis/hiredis.o hiredis/sds.o hiredis/net.o hiredis/async.o
+HIREDIS_OBJ?=hiredis/hiredis.o hiredis/sds.o hiredis/net.o hiredis/async.o hiredis/read.o hiredis/dict.o
 JANSSON_OBJ?=jansson/src/dump.o jansson/src/error.o jansson/src/hashtable.o jansson/src/load.o jansson/src/strbuffer.o jansson/src/utf.o jansson/src/value.o jansson/src/variadic.o
 B64_OBJS?=b64/cencode.o
 FORMAT_OBJS?=formats/json.o formats/raw.o formats/common.o formats/custom-type.o

=== debian/changelog ===
webdis (0.1.4+dfsg-1build2) focal; urgency=medium

  * No-change rebuild for libevent soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 19 Oct 2019 19:58:57 +0000

webdis (0.1.4+dfsg-1build1) disco; urgency=medium

  * No-change rebuild against libhiredis0.14

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 12 Nov 2018 08:49:41 +0000

webdis (0.1.4+dfsg-1) unstable; urgency=medium

  * New upstream version 0.1.4+dfsg
  * d/control, d/copyright: update maintainers email and proper name spelling.
  * Raise compat level to 11.
  * d/control: remove explicit *-dbg package definition.
  * d/control: bump Standards-Version to 4.2.0.
  * d/control: update Vcs-* fields to point to salsa.d.o.
  * d/control: add Rules-Requires-Root header set to no.
  * d/control: add direct build dependency on pkg-config.
  * d/webdis.install: no need to explicitly install webdis binary.
  * d/rules: remove DESTDIR and CONFDIR vars setup by hand.
  * d/rules: avoid installing webdis.prod.json from upstream.
  * d/control, d/rules: remove trailing whitespace.
  * d/control: remote unnecessary Testsuite header.
  * d/copyright: use https protocol.
  * Add systemd service configuration.
  * d/patches/fix-test-new-libevent.patch: fix pubsub test when compiled w/
    libevent 2.1.x. (Closes: #869951, #901555)
  * d/rules: use /usr/share/dpkg/buildflags.mk to populate build flags.
  * Fix lintian typo check

 -- Andrii Senkovych <andrii@senkovych.com>  Sun, 26 Aug 2018 15:30:36 +0300

webdis (0.1.2+dfsg-2) unstable; urgency=medium

  * Update testsuite variable names. Fixup to sockstat
  * Remove dependency on netstat or sockstat to run the tests

 -- Andriy Senkovych <jolly_roger@itblog.org.ua>  Thu, 17 Nov 2016 00:46:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: webdis
 Section: web
 Priority: optional
-Maintainer: Andrii Senkovych <andrii@senkovych.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrii Senkovych <andrii@senkovych.com>
 Build-Depends: debhelper (>= 11~),
     libevent-dev (>= 1.4.13),
     libhiredis-dev (>= 0.10),

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
include /usr/share/dpkg/buildflags.mk
CFLAGS += $(CPPFLAGS)

export PREFIX = /usr

# Objects to be removed from build procedure
export HIREDIS_OBJ=
export JANSSON_OBJ=
export B64_OBJS=

export CFLAGS += -I. -Ihttp-parser
export LDFLAGS += -levent -pthread -lhiredis -ljansson -lb64

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C tests pubsub websocket

override_dh_auto_clean:
	$(MAKE) clean
	$(MAKE) -C tests clean
	rm -f debian/files
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	rm debian/webdis/etc/webdis.prod.json

override_dh_auto_test:
ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	@echo "Skipping check (disabled in DEB_BUILD_OPTIONS)."
else
	$(CURDIR)/debian/test.sh $(MAKE) test
endif

=== debian/tests/control ===
Tests: webdis
Depends: @, redis-server, build-essential, libevent-dev,
 python-unittest2, python-msgpack, net-tools
Restrictions: isolation-container, allow-stderr

## webdis 0.1.9+dfsg

=== Makefile ===
OUT=webdis
HIREDIS_OBJ?=src/hiredis/hiredis.o src/hiredis/sds.o src/hiredis/net.o src/hiredis/async.o src/hiredis/read.o src/hiredis/dict.o
JANSSON_OBJ?=src/jansson/src/dump.o src/jansson/src/error.o src/jansson/src/hashtable.o src/jansson/src/load.o src/jansson/src/strbuffer.o src/jansson/src/utf.o src/jansson/src/value.o src/jansson/src/variadic.o
B64_OBJS?=src/b64/cencode.o
FORMAT_OBJS?=src/formats/json.o src/formats/raw.o src/formats/common.o src/formats/custom-type.o
HTTP_PARSER_OBJS?=src/http-parser/http_parser.o

CFLAGS ?= -O3 -Wall -Wextra -Isrc -Isrc/jansson/src -Isrc/http-parser -MD
LDFLAGS ?= -levent -pthread

# check for MessagePack
MSGPACK_LIB=$(shell ls /usr/lib/libmsgpack.so 2>/dev/null)
ifneq ($(strip $(MSGPACK_LIB)),)
	FORMAT_OBJS += src/formats/msgpack.o
	CFLAGS += -DMSGPACK=1
	LDFLAGS += -lmsgpack
else
# check for MessagePackC
MSGPACKC_LIB=$(shell ls /usr/lib/libmsgpackc.so 2>/dev/null)
ifneq ($(strip $(MSGPACKC_LIB)),)
	FORMAT_OBJS += src/formats/msgpack.o
	CFLAGS += -DMSGPACK=1
	LDFLAGS += -lmsgpackc
endif
endif


OBJS_DEPS=$(wildcard *.d)
DEPS=$(FORMAT_OBJS) $(HIREDIS_OBJ) $(JANSSON_OBJ) $(HTTP_PARSER_OBJS) $(B64_OBJS)
OBJS=src/webdis.o src/cmd.o src/worker.o src/slog.o src/server.o src/acl.o src/md5/md5.o src/sha1/sha1.o src/http.o src/client.o src/websocket.o src/pool.o src/conf.o $(DEPS)



PREFIX ?= /usr/local
CONFDIR ?= $(DESTDIR)/etc

INSTALL_DIRS = $(DESTDIR) \
	       $(DESTDIR)/$(PREFIX) \
	       $(DESTDIR)/$(PREFIX)/bin \
	       $(CONFDIR)

all: $(OUT) Makefile

$(OUT): $(OBJS) Makefile
	$(CC) -o $(OUT) $(OBJS) $(LDFLAGS)

%.o: %.c %.h Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

%.o: %.c Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

$(INSTALL_DIRS):
	mkdir -p $@

clean:
	rm -f $(OBJS) $(OUT) $(OBJS_DEPS)

install: $(OUT) $(INSTALL_DIRS)
	cp $(OUT) $(DESTDIR)/$(PREFIX)/bin
	cp webdis.prod.json $(CONFDIR)


WEBDIS_PORT ?= 7379

test_all: test perftest

test:
	python tests/basic.py
	python tests/limits.py
	./tests/pubsub -p $(WEBDIS_PORT)

perftest:
	# This is a performance test that requires apache2-utils and curl
	./tests/bench.sh

-include $(OBJS:.o=.d)

=== tests/Makefile ===
OUT=websocket pubsub
CFLAGS=-O3 -Wall -Wextra
LDFLAGS=-levent -lpthread -lrt

all: $(OUT) Makefile

websocket: websocket.o
	$(CC) -o $@ $< $(LDFLAGS)

pubsub: pubsub.o
	$(CC) -o $@ $< $(LDFLAGS)

%.o: %.c Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

clean:
	rm -f *.o $(OUT)

=== debian/changelog ===
webdis (0.1.9+dfsg-1) unstable; urgency=medium

  * d/copyright: acknowledge upstream files relocation
  * New upstream version 0.1.9+dfsg
  * Refresh patches
  * Update include locations
  * d/copyright: fix whitespace
  * d/test.sh: fix whitespace
  * d/webdis.service: do not fail on mkdir (Closes: #940558) Thanks to
    Emmanuel Benoît
  * d/control: bump Standards-Version to 4.5.0 (no changes)

 -- Andrii Senkovych <andrii@senkovych.com>  Thu, 23 Apr 2020 02:04:04 +0300

webdis (0.1.4+dfsg-2) unstable; urgency=medium

  * Post unittests to python3; Closes: #943271, #951624

 -- Sandro Tosi <morph@debian.org>  Fri, 10 Apr 2020 02:40:29 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: webdis
 Section: web
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andrii Senkovych <andrii@senkovych.com>
+Maintainer: Andrii Senkovych <andrii@senkovych.com>
 Build-Depends: debhelper (>= 11~),
     libevent-dev (>= 1.4.13),
     libhiredis-dev (>= 0.10),
@@ -10,10 +9,9 @@
     libb64-dev (>= 1.2),
     libmsgpack-dev,
     redis-server,
-    python-unittest2,
-    python-msgpack (>= 0.3),
-    pkg-config
-Standards-Version: 4.2.0
+    pkg-config,
+    python3,
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian/webdis.git
 Vcs-Browser: https://salsa.debian.org/debian/webdis
 Homepage: http://webd.is

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 export JANSSON_OBJ=
 export B64_OBJS=
 
-export CFLAGS += -I. -Ihttp-parser
+export CFLAGS += -Isrc -Isrc/http-parser
 export LDFLAGS += -levent -pthread -lhiredis -ljansson -lb64
 
 %:

=== debian/watch ===
version=3
opts=dversionmangle=s/\+(dfsg|ds)$//,repacksuffix=+dfsg \
    https://github.com/nicolasff/webdis/releases \
    .*\/([0-9.]+)\.tar\.gz

## webdis 0.1.22+ds

=== Makefile ===
OUT=webdis
HIREDIS_OBJ?=src/hiredis/hiredis.o src/hiredis/sds.o src/hiredis/net.o src/hiredis/async.o src/hiredis/read.o src/hiredis/dict.o src/hiredis/alloc.o src/hiredis/sockcompat.o
JANSSON_OBJ?=src/jansson/src/dump.o src/jansson/src/error.o src/jansson/src/hashtable.o src/jansson/src/load.o src/jansson/src/strbuffer.o src/jansson/src/utf.o src/jansson/src/value.o src/jansson/src/variadic.o
B64_OBJS?=src/b64/cencode.o
FORMAT_OBJS?=src/formats/json.o src/formats/raw.o src/formats/common.o src/formats/custom-type.o
HTTP_PARSER_OBJS?=src/http-parser/http_parser.o

CFLAGS ?= -std=c99 -Wall -Wextra -Isrc -Isrc/jansson/src -Isrc/http-parser -MD -D_POSIX_C_SOURCE=200809L -Wno-pragmas
LDFLAGS ?= -levent -pthread

# Pass preprocessor macros to the compile invocation
CFLAGS += $(CPPFLAGS)

# check for MessagePack
MSGPACK_LIB=$(shell ls /usr/lib/libmsgpack.so 2>/dev/null)
ifneq ($(strip $(MSGPACK_LIB)),)
	FORMAT_OBJS += src/formats/msgpack.o
	CFLAGS += -DMSGPACK=1
	LDFLAGS += -lmsgpack
else
# check for MessagePackC
MSGPACKC_LIB=$(shell ls /usr/lib/libmsgpackc.so 2>/dev/null)
ifneq ($(strip $(MSGPACKC_LIB)),)
	FORMAT_OBJS += src/formats/msgpack.o
	CFLAGS += -DMSGPACK=1
	LDFLAGS += -lmsgpackc
else
# check for MessagePack on macOS
MSGPACK_OSX_LIB=$(shell ls /usr/local/lib/libmsgpackc.dylib 2>/dev/null)
ifneq ($(strip $(MSGPACK_OSX_LIB)),)
	FORMAT_OBJS += src/formats/msgpack.o
	CFLAGS += -DMSGPACK=1
	LDFLAGS += -lmsgpackc
else
# check for MessagePackC using ld (returns 1 in both cases on macOS)
MSGPACKC_LD=$(shell ld -lmsgpackc >/dev/null 2>/dev/null; echo $$?)
ifeq ($(strip $(MSGPACKC_LD)),0)
	FORMAT_OBJS += src/formats/msgpack.o
	CFLAGS += -DMSGPACK=1
	LDFLAGS += -lmsgpackc
endif
endif
endif
endif

# if `make` is run with DEBUG=1, include debug symbols
DEBUG_FLAGS=
ifeq ($(DEBUG),1)
	DEBUG_FLAGS += -O0
	ifeq ($(shell cc -v 2>&1 | grep -cw 'gcc version'),1) # GCC used: add GDB debugging symbols
		DEBUG_FLAGS += -ggdb3
	else ifeq ($(shell gcc -v 2>&1 | grep -cw 'clang version'),1) # Clang used: add LLDB debugging symbols
		DEBUG_FLAGS += -g3 -glldb
	endif
else
	DEBUG_FLAGS += -O3
endif

CFLAGS += $(DEBUG_FLAGS)

# if `make` is run with SSL=1, include hiredis SSL support
ifeq ($(SSL),1)
	HIREDIS_OBJ += src/hiredis/ssl.o
	CFLAGS += -DHAVE_SSL=1
	LDFLAGS +=  -lssl -lcrypto
	ifneq (, $(shell which brew)) # Homebrew
		CFLAGS += -I$(shell brew --prefix)/opt/openssl/include
		LDFLAGS += -L$(shell brew --prefix)/opt/openssl/lib
	endif
	# On Ubuntu and Alpine, LDFLAGS are enough since the SSL headers are under /usr/include/openssl
endif

OBJS_DEPS=$(wildcard *.d)
DEPS=$(FORMAT_OBJS) $(HIREDIS_OBJ) $(JANSSON_OBJ) $(HTTP_PARSER_OBJS) $(B64_OBJS)
OBJS=src/webdis.o src/cmd.o src/worker.o src/slog.o src/server.o src/acl.o src/md5/md5.o src/sha1/sha1.o src/http.o src/client.o src/websocket.o src/pool.o src/conf.o $(DEPS)


PREFIX ?= /usr/local
CONFDIR ?= $(DESTDIR)/etc
SELF_DIR:=$(shell dirname $(realpath $(firstword $(MAKEFILE_LIST))))

INSTALL_DIRS = $(DESTDIR)$(PREFIX) \
	       $(DESTDIR)$(PREFIX)/bin \
	       $(CONFDIR)

all: $(OUT) Makefile

$(OUT): $(OBJS) Makefile
	$(CC) -o $(OUT) $(OBJS) $(LDFLAGS)

%.o: %.c %.h Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

%.o: %.c Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

$(INSTALL_DIRS):
	mkdir -p $@

clean:
	rm -f $(OBJS) $(OUT) $(OBJS_DEPS)
	find "$(SELF_DIR)" -name '*.d' -delete

install: $(OUT) $(INSTALL_DIRS)
	cp $(OUT) $(DESTDIR)$(PREFIX)/bin
	cp webdis.prod.json $(CONFDIR)


WEBDIS_PORT ?= 7379

test_all: test perftest

test:
	python3 tests/basic.py
	python3 tests/limits.py
	./tests/pubsub -p $(WEBDIS_PORT)

perftest:
	# This is a performance test that requires apache2-utils and curl
	./tests/bench.sh

-include $(OBJS:.o=.d)

=== tests/Makefile ===
OUT=websocket pubsub
OBJS=../src/http-parser/http_parser.o ../src/b64/cencode.o ../src/sha1/sha1.o
CFLAGS=-Wall -Wextra -I../src -I../src/http-parser
LDFLAGS=-levent -lpthread -lm

# if `make` is run with DEBUG=1, include debug symbols (same as in Makefile in root directory)
DEBUG_FLAGS=
ifeq ($(DEBUG),1)
	DEBUG_FLAGS += -O0
	ifeq ($(shell cc -v 2>&1 | grep -cw 'gcc version'),1) # GCC used: add GDB debugging symbols
		DEBUG_FLAGS += -ggdb3
	else ifeq ($(shell gcc -v 2>&1 | grep -cw 'clang version'),1) # Clang used: add LLDB debugging symbols
		DEBUG_FLAGS += -g3 -glldb
	endif
else
	DEBUG_FLAGS += -O3
endif
CFLAGS += $(DEBUG_FLAGS)

all: $(OUT) Makefile

websocket: websocket.o $(OBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

pubsub: pubsub.o
	$(CC) -o $@ $< $(LDFLAGS)

%.o: %.c Makefile
	$(CC) -c $(CFLAGS) -o $@ $<

clean:
	rm -f *.o $(OUT) $(OBJS)

=== tests/requirements.txt ===
websocket-client>=1.1.0

=== debian/changelog ===
webdis (0.1.22+ds-1) unstable; urgency=medium

  * Use +ds as repacksuffix since the repacking is just to remove embedded
    copies of already packaged libraries.
  * New upstream version
    + Use correct signature for on_msgpack_write, fixing FTBFS with GCC-14.
      (Closes: #1075636)
  * Remove backported patches (backport-msgpack-support.patch, python3.patch)
    and patches applied upstream (tests.patch, print-listen-port-number.patch)
  * rules:
    + Stop adding CPPFLAGS to CFLAGS since upstream respects CPPFLAGS now
    + Use DEB_..._MAINT_APPEND to augment CFLAGS/LDFLAGS
    + Use pkgconf to determine cflags/ldflags for dependency libs
    + Enable all hardening build flags
  * Add a new patch to build against system b64 lib for tests
  * Install new upstream documentation
  * Enable new SSL support
  * Add Pre-Depends to pick up defined ${misc:Pre-Depends}
  * autopkgtests: Add libb64-dev to Depends

 -- James McCoy <jamessan@debian.org>  Mon, 29 Jul 2024 11:39:32 -0400

webdis (0.1.9+dfsg-3) unstable; urgency=medium

  * Reinstate changes from 0.1.9+dfsg-1.1 NMU

 -- James McCoy <jamessan@debian.org>  Mon, 17 Jun 2024 15:24:45 -0400

webdis (0.1.9+dfsg-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Replace /var/run with /run for the Service PIDFile.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on libb64-dev, libevent-dev,
      libhiredis-dev and libjansson-dev.
    + webdis: Drop versioned constraint on lsb-base in Depends.

  [ James McCoy ]
  * Drop current msgpack patches
  * Backport upstream changes for msgpack detection (Closes: #1070694)
  * Remove a.out file during clean
  * Remove pkg-config Build-Depends, since upstream msgpack detection doesn't
    use it
  * Remove obsolete lsb-base Depends

 -- James McCoy <jamessan@debian.org>  Tue, 04 Jun 2024 21:56:08 -0400

webdis (0.1.9+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * ignore deluser not being available in postrm purge (closes: #1035435)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 18 May 2023 00:10:16 +0200

=== debian/control ===
--- 
+++ 
@@ -2,24 +2,26 @@
 Section: web
 Priority: optional
 Maintainer: Andrii Senkovych <andrii@senkovych.com>
-Build-Depends: debhelper (>= 11~),
-    libevent-dev (>= 1.4.13),
-    libhiredis-dev (>= 0.10),
-    libjansson-dev (>= 1.3),
-    libb64-dev (>= 1.2),
+Build-Depends: debhelper-compat (= 13),
+    libevent-dev,
+    libhiredis-dev,
+    libjansson-dev,
+    libb64-dev,
     libmsgpack-dev,
+    libssl-dev,
     redis-server,
-    pkg-config,
+    pkgconf,
     python3,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/debian/webdis.git
 Vcs-Browser: https://salsa.debian.org/debian/webdis
-Homepage: http://webd.is
+Homepage: https://webd.is
 Rules-Requires-Root: no
 
 Package: webdis
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lsb-base (>= 3.0-6)
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Suggests: redis-server
 Description: simple web server providing an HTTP interface to Redis
  Webdis is a simple web server providing HTTP interface to Redis. Some features

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,14 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+DEB_CFLAGS_MAINT_APPEND = -std=c99 -Isrc -Isrc/http-parser -D_POSIX_C_SOURCE=200809L -Wno-pragmas
+DEB_CFLAGS_MAINT_APPEND += $(shell pkg-config --cflags hiredis_ssl jansson openssl libevent)
+DEB_LDFLAGS_MAINT_APPEND = -pthread -lb64
+DEB_LDFLAGS_MAINT_APPEND += $(shell pkg-config --libs hiredis_ssl jansson openssl libevent)
+DEB_CPPFLAGS_MAINT_APPEND = -DHAVE_SSL=1
+DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
-CFLAGS += $(CPPFLAGS)
 
 export PREFIX = /usr
 
@@ -11,9 +16,6 @@
 export HIREDIS_OBJ=
 export JANSSON_OBJ=
 export B64_OBJS=
-
-export CFLAGS += -Isrc -Isrc/http-parser
-export LDFLAGS += -levent -pthread -lhiredis -ljansson -lb64
 
 %:
 	dh $@
@@ -26,7 +28,7 @@
 	$(MAKE) clean
 	$(MAKE) -C tests clean
 	rm -f debian/files
-	dh_auto_clean
+	rm -f a.out
 
 override_dh_auto_install:
 	dh_auto_install

=== debian/tests/control ===
Tests: webdis
Depends: @, redis-server, build-essential, libevent-dev,
 net-tools, python3, libb64-dev
Restrictions: isolation-container, allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain,dversionmangle=s/\+(dfsg|ds)$//,repacksuffix=+ds" \
   https://api.github.com/repos/nicolasff/webdis/tags?per_page=100 \
   https://api.github.com/repos/nicolasff/webdis/tarball/refs/tags/@ANY_VERSION@
